module Intersail
  module Rpdf
    class TagArray
      attr_reader :array

      def initialize(node)
        @array = []
        build_array(node) if(node.respond_to?(:has_children?) && node.has_children?)
      end

      private

      def build_array(node, basename = '')
        if node.name.present?
          basename =  basename.empty? ? node.name : "#{basename}.#{node.name}"
        end

        node.children.each do |child|
          if(child.has_children?)
            build_array(child, basename)
          else
            @array.append(basename.empty? ? child.name : "#{basename}.#{child.name}")
          end
        end
      end
    end
  end
end
